function [subproblems] = evolve(subproblems, mop, img_params)
    global idealpoint ideali;
    for i=1:length(subproblems)
        ind = genetic_op(subproblems, i, img_params.lib_size);
        [obj,ind] = evaluate(mop, ind, img_params);
        a = [idealpoint, obj];
        [~, b] = min(sqrt(sum(a.^2,1)));
        idealpoint = a(:,b);
        if b==2
            ideali = ind;
        end
        neighbourindex = subproblems(i).neighbour;
        subproblems(neighbourindex)=update(subproblems(neighbourindex),ind, idealpoint, ideali);
    end
end

%%
function ind=genetic_op(subproblems, index, m)
    oldpoint = subproblems(index).curpoint.parameter;
    newpoint = abs(oldpoint-randsrc(m,1,[1,0; 1/m,1-1/m]));  
    ind = struct('parameter',newpoint,'objective',[], 'estimation',[]);
end

%%
function subp =update(subp, ind, idealpoint, ideali)    
    newobj=te([subp.weight], ind,  idealpoint, ideali);
    oops = [subp.curpoint]; 
    oldobj=te([subp.weight], oops, idealpoint, ideali);
    C = newobj < oldobj;
    [subp(C).curpoint]= deal(ind);
end

%%
function obj = te(weight, ind, idealpoint, ideali)
    global img_params lambda
    s = size(weight, 2);
    indsize = size(ind,2);
    weight((weight == 0))=0.00001;
    if indsize==s 
        part2 = abs([ind.objective]-idealpoint(:,ones(1, indsize)));
        SID_all = zeros(1,s);
        for i=1:s
            SID_all(i) = SID(ind(i).parameter,ideali.parameter,img_params.lib);
        end
        obj = max(weight.*part2)+lambda*SID_all;
    elseif indsize ==1
        part2 = abs(ind.objective-idealpoint);
        obj = max(weight.*part2(:,ones(1, s)))+lambda*repmat(SID(ind.parameter,ideali.parameter,img_params.lib),[1,s]);
    end
end