function [idealp, ideali, params, subproblems]=init(mop, img_params, propertyArgIn)
    objDim=mop.od;
    while length(propertyArgIn)>=2
        prop = propertyArgIn{1};
        val=propertyArgIn{2};
        propertyArgIn=propertyArgIn(3:end);
        switch prop
            case 'popsize'
                params.popsize=val;
            case 'niche'
                params.niche=val;
            case 'iteration'
                params.iteration=val;
            case 'iter_lambda'
                params.iter_lambda=val;
            case 'method'
                params.dmethod=val;
            otherwise
                warning('moea doesnot support the given parameters name');
        end
    end
    subproblems = init_weights(params.popsize, params.niche, objDim);
    params.popsize = length(subproblems);
    inds = randompoint(mop, params.popsize);
    [V, INDS] = arrayfun(@evaluate, repmat(mop, size(inds)), inds, repmat(img_params, size(inds)), 'UniformOutput', 0);
    v = cell2mat(V);
    [~, a] = min(sqrt(sum(v.^2,1)));
    idealp = v(:,a);
    ideali = cell2mat(INDS(a));
    [subproblems.curpoint] = INDS{:};
    clear inds INDS V indcells a;
end

%%
function subp=init_weights(popsize, niche, objDim)
    subp=[];
    for i=0:popsize
        if objDim==2
            p=struct('weight',[],'neighbour',[],'optimal', Inf, 'optpoint',[], 'curpoint', []);
            weight=zeros(2,1);
            weight(1)=i/popsize;
            weight(2)=(popsize-i)/popsize;
            p.weight=weight;
            subp=[subp p];
        elseif objDim==3
        end
    end

    leng=length(subp);
    distanceMatrix=zeros(leng, leng);
    for i=1:leng
        for j=i+1:leng
            A=subp(i).weight;B=subp(j).weight;
            distanceMatrix(i,j)=(A-B)'*(A-B);
            distanceMatrix(j,i)=distanceMatrix(i,j);
        end
        [~,sindex]=sort(distanceMatrix(i,:));
        subp(i).neighbour=sindex(1:niche)';
    end
end

%%
function ind = randompoint(prob, n)
if (nargin==1)
    n=1;
end

point = randsrc(prob.pd,n,[1,0; 1/prob.pd,1-1/prob.pd]);
cellpoints = num2cell(point, 1);

indiv = struct('parameter',[],'objective',[], 'estimation', []);
ind = repmat(indiv, 1, n);
[ind.parameter] = cellpoints{:};
end